package metaedit.style;

import java.awt.Color;
import java.awt.font.TextAttribute;

import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import metaconfig.types.Properties;

public abstract class EditorStyle {
	private SimpleAttributeSet attributeSet = new SimpleAttributeSet();

	private Properties properties;

	private TextAttribute textAttribute;

	public EditorStyle() {
		setBackgroundColor(Color.WHITE);
		setForegroundColor(Color.BLACK);
	}

	public void setBackgroundColor(Color bgColor) {
		StyleConstants.setBackground(attributeSet, bgColor);
	}

	public void setForegroundColor(Color fgColor) {
		StyleConstants.setForeground(attributeSet, fgColor);
	}

	public void setStyle(StyledDocument document, int offset, int length) {
		document.setCharacterAttributes(offset, length, attributeSet, true);
	}
}